#ifndef _CPUID_H_
#define _CPUID_H_

#define CPU_FEATURE_FPU 	0x01   		/* 0. FPU Supported */
#define CPU_FEATURE_VME 	0x02    	/* 1. Virtual Mode Extensions */
#define CPU_FEATURE_DEBUG 	0x04   		/* 2. Breakpoint functions */
#define CPU_FEATURE_PAGESIZE 	0x08		/* 3. Page Size Extensions */
#define CPU_FEATURE_TIMESTAMP 	0x10		/* 4. Time Stanmping */
#define CPU_FEATURE_MSR		0x20 		/* 5. Model Specific registerrs */
#define CPU_FEATURE_PAE		0x40 		/* 6. Page Addres Extensions */
#define CPU_FEATURE_MCE		0x80 		/* 7. Machine Check Exception */
#define CPU_FEATURE_CMPXCHG8	0x100  		/* 8. Compare exchange 8 byte instruction */
#define CPU_FEATURE_APIC	0x200  		/* 9. APIC present */
#define CPU_FEATURE_10		0x400		/* 10 CPU Feature 10 */.
#define CPU_FEATURE_SYSCALL	0x800 	 	/* 11. Fast system call extensions */
#define CPU_FEATURE_MTRR	0x1000  	/* 12. Memory Type/range regs supported */
#define CPU_FEATURE_GPAGE	0x2000  	/* 13. Global paging register */
#define CPU_FEATURE_MCA		0x4000  	/* 14. Machine CHeck Architecture */
#define CPU_FEATURE_CMI		0x8000  	/* 15. COnditional move instructions */
#define CPU_FEATURE_PAT		0x10000l  	/* 16. Page Atribute table */
#define CPU_FEATURE_PAE36    	0x20000l  	/* 17. Page address extensions to 36 bits */
#define CPU_FEATURE_PSN		0x40000l	/* 18  Processor Serial Number.*/
#define CPU_FEATURE_CLFLUSH	0x80000l	/* 19. Has CLFLUSH Instruction */
#define CPU_FEATURE_20		0x100000l	/* 20. */
#define CPU_FEATURE_DS		0x200000l	/* 21 Has Debug Store (Intel) */
#define CPU_FEATURE_AMDMMX	0x400000l	/* 22 AMD MMX Extensions */
#define CPU_FEATURE_MMX		0x800000l	/* 23 INTEL MMX */
#define CPU_FEATURE_FXSAVE	0x1000000l	/* 24 Fast FP Save */
#define CPU_FEATURE_SIMD	0x2000000l	/* 25 Intel SIMD */
#define CPU_FEATURE_SIMD2	0x4000000l	/* 26 INtel SIMD 2 */
#define CPU_FEATURE_SNOOP	0x8000000l
#define CPU_FEATURE_28		0x10000000l	/* 28 */
#define CPU_FEATURE_THERMMON	0x20000000l	/* 29 */
#define CPU_FEATURE_3DNOWEXT	0x40000000l	/* 30 AMD 3DNow! Extensions */
#define CPU_FEATURE_3DNOW	0x80000000l	/* 31 AMD 3DNow! */

#define CPU_VENDOR_AMD 1
#define CPU_VENDOR_INTEL 0
#define CPU_VENDOR_CYRIX 2


typedef struct cpuid_s
{
	unsigned long eax,ebx,ecx,edx;
	int brand,apic,vendor;
	int ex_family,ex_model,cpu_type,family,model,stepping;
	unsigned long features,ex_features;
	char IdString[13];
	int nocpuid;

} cpuid_t;

cpuid_t CPUID_GetId(void);
int CPUID_IsVendor(int vendor);
int CPUID_IsFeatureAvailable(unsigned long feature);

#endif

