#include "config.h"

#include <assert.h>
#include <errno.h>
#include <stdio.h>
#include <signal.h>
#include <sys/types.h>
#include "sunptrace.h"
#ifdef HAVE_SYS_PTRACE_H
# include <sys/ptrace.h>
#endif
#ifdef HAVE_SYS_WAIT_H
# include <sys/wait.h>
#endif
#include <unistd.h>

#include "file.h"
#include "process.h"
#include "thread.h"

#ifndef PTRACE_CONT
#define PTRACE_CONT PT_CONTINUE
#endif
#ifndef PTRACE_SINGLESTEP
#define PTRACE_SINGLESTEP PT_STEP
#endif
#ifndef PTRACE_ATTACH
#define PTRACE_ATTACH PT_ATTACH
#endif
#ifndef PTRACE_DETACH
#define PTRACE_DETACH PT_DETACH
#endif
#ifndef PTRACE_PEEKDATA
#define PTRACE_PEEKDATA PT_READ_D
#endif
#ifndef PTRACE_POKEDATA
#define PTRACE_POKEDATA PT_WRITE_D
#endif

#include "sunptrace.h"

int sunptrace(int request, pid_t pid, int addr, int data){

  switch (request){

    case    PTRACE_TRACEME:
     			errno=EPERM; return (-1);
  			break;
   case     PTRACE_PEEKTEXT:
    			errno=EPERM; return (-1);
 			break;
    case     PTRACE_PEEKDATA:
    			errno=EPERM; return (-1);
			break;
    case     PTRACE_PEEKUSR:
    			errno=EPERM; return (-1);
			break;
    case     PTRACE_POKETEXT:
    			errno=EPERM; return (-1);
			break;
    case     PTRACE_POKEDATA:
    			errno=EPERM; return (-1);
			break;
    case     PTRACE_POKEUSR:
    			errno=EPERM; return (-1);
			break;
    case     PTRACE_CONT:
    			errno=EPERM; return (-1);
			break;
    case     PTRACE_KILL:
    			errno=EPERM; return (-1);
			break;
    case     PTRACE_SINGLESTEP:
    			errno=EPERM; return (-1);
			break;
    case     PTRACE_ATTACH:
    			errno=EPERM; return (-1);
			break;
    case     PTRACE_DETACH:
    			errno=EPERM; return (-1);
			break;
    case     PTRACE_SYSCALL:
    			errno=EPERM; return (-1);
			break;
    case     PTRACE_GETREGS:
    			errno=EPERM; return (-1);
			break;
    case     PTRACE_SETREGS:
    			errno=EPERM; return (-1);
			break;
    case     PTRACE_GETFPREGS:
    			errno=EPERM; return (-1);
			break;
    case     PTRACE_SETFPREGS:
    			errno=EPERM; return (-1);
			break;

    default:
    errno=EIO;
    return (-1);
  }
}


/*
Implementation
*/

static int ptrace_attach(pid_t pid, int addr, int data)
{
// Attach a process for debugging
}
static int ptrace_dettach(pid_t pid, int addr, int data)
{
// Detach a process for debugging
}
static int ptrace_peektext(pid_t pid, int addr, int data)
{
// Attach a process for debugging
}

static int ptrace_poketext(pid_t pid, int addr, int data)
{
// Attach a process for debugging
}
static int ptrace_peekdata(pid_t pid, int addr, int data)
{
// Attach a process for debugging
}
static int ptrace_pokedata(pid_t pid, int addr, int data)
{
// Attach a process for debugging
}
static int ptrace_peekusr(pid_t pid, int addr, int data)
{
// Attach a process for debugging
}
static int ptrace_pokeusr(pid_t pid, int addr, int data)
{
// Attach a process for debugging
}
static int ptrace_getregs(pid_t pid, int addr, int data)
{
// Attach a process for debugging
}
static int ptrace_setregs(pid_t pid, int addr, int data)
{
// Attach a process for debugging
}
static int ptrace_getfpregs(pid_t pid, int addr, int data)
{
// Attach a process for debugging
}
static int ptrace_setfpregs(pid_t pid, int addr, int data)
{
// Attach a process for debugging
}
static int ptrace_cont(pid_t pid, int addr, int data)
{
// Attach a process for debugging
}
static int ptrace_step(pid_t pid, int addr, int data)
{
// Attach a process for debugging
}
static int ptrace_syscall(pid_t pid, int addr, int data)
{
// Attach a process for debugging
}
static int ptrace_kill(pid_t pid, int addr, int data)
{
// Attach a process for debugging
}


