#ifndef _SUNPTRACE_H_
#define _SUNPTRACE_H_


/*
Copyright Robert Lunnon 2003

GPL Licenced Source Code

*/


/*
Solaris doesn't define ptrace the same as linux, from Solaris 9
ptrace is a library call based on the proc filesystem

This code also based on /proc is desined to emulate the Linux ptrace

*/

#include <unistd.h>
#include <sys/types.h>


#define LINUX_OPCODE_OFFSET 0x100

#define     PTRACE_TRACEME	0
#define     PTRACE_PEEKTEXT	1
#define     PTRACE_PEEKDATA	2
#define     PTRACE_PEEKUSR	3
#define     PTRACE_POKETEXT	4
#define     PTRACE_POKEDATA	5
#define     PTRACE_POKEUSR	6
#define     PTRACE_CONT		7
#define     PTRACE_KILL		8
#define     PTRACE_SINGLESTEP	9
#define     PTRACE_ATTACH	LINUX_OPCODE_OFFSET+0
#define     PTRACE_DETACH 	LINUX_OPCODE_OFFSET+1
#define     PTRACE_SYSCALL	LINUX_OPCODE_OFFSET+2
#define     PTRACE_GETREGS	LINUX_OPCODE_OFFSET+3
#define     PTRACE_SETREGS	LINUX_OPCODE_OFFSET+4
#define     PTRACE_GETFPREGS	LINUX_OPCODE_OFFSET+5
#define     PTRACE_SETFPREGS	LINUX_OPCODE_OFFSET+6




     int sunptrace(int request, pid_t pid, int addr, int data);

#endif
